"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createCallContext = void 0;
const nice_grpc_common_1 = require("nice-grpc-common");
const convertMetadata_1 = require("../utils/convertMetadata");
/** @internal */
function createCallContext(call) {
    const header = (0, nice_grpc_common_1.Metadata)();
    const trailer = (0, nice_grpc_common_1.Metadata)();
    const abortController = new AbortController();
    if (call.cancelled) {
        abortController.abort();
    }
    else {
        call.on('cancelled', () => {
            abortController.abort();
        });
    }
    let headerSent = false;
    return {
        metadata: (0, convertMetadata_1.convertMetadataFromGrpcJs)(call.metadata),
        peer: call.getPeer(),
        header,
        sendHeader() {
            if (headerSent) {
                return;
            }
            call.sendMetadata((0, convertMetadata_1.convertMetadataToGrpcJs)(header));
            headerSent = true;
        },
        trailer,
        signal: abortController.signal,
    };
}
exports.createCallContext = createCallContext;
//# sourceMappingURL=createCallContext.js.map